package entity

type KindBoxType uint

// const (
// KindBoxPendingSendStatus KindBoxType = iota + 1
// KindBoxSentStatus
// KindBoxPendingReceivedStatus
// KindBoxReceivedStatus
// KindBoxEnumeratedStatus
// )

var KindBoxTypeStrings = map[KindBoxType]string{
	// KindBoxPendingSendStatus:     "pending-send",
	// KindBoxSentStatus:            "sent",
	// KindBoxPendingReceivedStatus: "pending-received",
	// KindBoxReceivedStatus:        "received",
	// KindBoxEnumeratedStatus:      "enumerated",
}

func (s KindBoxType) String() string {
	return KindBoxTypeStrings[s]
}

// AllKindBoxType returns a slice containing all string values of KindBoxType.
func AllKindBoxType() []string {
	statusStrings := make([]string, len(KindBoxTypeStrings))
	for status, str := range KindBoxTypeStrings {
		statusStrings[int(status)-1] = str
	}

	return statusStrings
}

// MapToKindBoxType converts a string to the corresponding KindBoxType value.
func MapToKindBoxType(statusStr string) KindBoxType {
	for status, str := range KindBoxTypeStrings {
		if str == statusStr {
			return status
		}
	}

	return KindBoxType(0)
}
