package benefactorservice

import (
	"context"

	"git.gocasts.ir/ebhomengo/niki/entity"
)

type Repository interface {
	Register(benefactor entity.Benefactor) (entity.Benefactor, error)
	GetUserByPhoneNumber(phoneNumber string) (entity.Benefactor, error)
	GetUserByID(ctx context.Context, userID uint) (entity.Benefactor, error)
}

type AuthGenerator interface {
	CreateAccessToken(benefactor entity.Benefactor) (string, error)
	CreateRefreshToken(benefactor entity.Benefactor) (string, error)
}

type Service struct {
	auth AuthGenerator
	repo Repository
}

func New(authGenerator AuthGenerator, repo Repository) Service {
	return Service{auth: authGenerator, repo: repo}
}
